ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.34
Committed: Thu Mar 15 02:32:19 2012 UTC (12 years, 1 month ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.33: +7 -1 lines
Log Message:
Fix for -t3 N -t -1

File Contents

# Content
1 #!/usr/bin/perl -w
2 # RCSid $Id: genBSDF.pl,v 2.33 2012/03/06 04:41:31 greg Exp $
3 #
4 # Compute BSDF based on geometry and material description
5 #
6 # G. Ward
7 #
8 use strict;
9 use File::Temp qw/ :mktemp /;
10 sub userror {
11 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12 exit 1;
13 }
14 my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15 chomp $td;
16 my @savedARGV = @ARGV;
17 my $tensortree = 0;
18 my $ttlog2 = 4;
19 my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21 my $mgfin = 0;
22 my $geout = 1;
23 my $nproc = 1;
24 my $doforw = 0;
25 my $doback = 1;
26 my $pctcull = 90;
27 my $gunit = "Meter";
28 my @dim;
29 # Get options
30 while ($#ARGV >= 0) {
31 if ("$ARGV[0]" =~ /^[-+]m/) {
32 $mgfin = ("$ARGV[0]" =~ /^\+/);
33 } elsif ("$ARGV[0]" eq "-r") {
34 $rtargs = "$rtargs $ARGV[1]";
35 shift @ARGV;
36 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
37 $geout = ("$ARGV[0]" =~ /^\+/);
38 $gunit = $ARGV[1];
39 if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
40 die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
41 }
42 shift @ARGV;
43 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
44 $doforw = ("$ARGV[0]" =~ /^\+/);
45 } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46 $doback = ("$ARGV[0]" =~ /^\+/);
47 } elsif ("$ARGV[0]" eq "-t") {
48 # Use value < 0 for rttree_reduce bypass
49 $pctcull = $ARGV[1];
50 shift @ARGV;
51 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52 $tensortree = substr($ARGV[0], 2, 1);
53 $ttlog2 = $ARGV[1];
54 shift @ARGV;
55 } elsif ("$ARGV[0]" eq "-c") {
56 $nsamp = $ARGV[1];
57 shift @ARGV;
58 } elsif ("$ARGV[0]" eq "-n") {
59 $nproc = $ARGV[1];
60 shift @ARGV;
61 } elsif ("$ARGV[0]" =~ /^-d/) {
62 userror() if ($#ARGV < 6);
63 @dim = @ARGV[1..6];
64 shift @ARGV for (1..6);
65 } elsif ("$ARGV[0]" =~ /^[-+]./) {
66 userror();
67 } else {
68 last;
69 }
70 shift @ARGV;
71 }
72 # Check that we're actually being asked to do something
73 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
74 # Name our own persist file?
75 my $persistfile;
76 if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
77 $persistfile = "$td/pfile.txt";
78 $rtargs = "-PP $persistfile $rtargs";
79 }
80 # Get scene description and dimensions
81 my $radscn = "$td/device.rad";
82 my $mgfscn = "$td/device.mgf";
83 my $octree = "$td/device.oct";
84 if ( $mgfin ) {
85 system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
86 die "Could not load MGF input\n" if ( $? );
87 system "mgf2rad $mgfscn > $radscn";
88 } else {
89 system "xform -e @ARGV > $radscn";
90 die "Could not load Radiance input\n" if ( $? );
91 system "rad2mgf $radscn > $mgfscn" if ( $geout );
92 }
93 if ($#dim != 5) {
94 @dim = split ' ', `getbbox -h $radscn`;
95 }
96 print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
97 # Add receiver surfaces (rectangular)
98 my $fmodnm="receiver_face";
99 my $bmodnm="receiver_behind";
100 open(RADSCN, ">> $radscn");
101 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
102 print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
103 print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
104 print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
105 close RADSCN;
106 # Generate octree
107 system "oconv -w $radscn > $octree";
108 die "Could not compile scene\n" if ( $? );
109 # Output XML prologue
110 print
111 '<?xml version="1.0" encoding="UTF-8"?>
112 <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
113 ';
114 print "<!-- File produced by: genBSDF @savedARGV -->\n";
115 print
116 '<WindowElementType>System</WindowElementType>
117 <Optical>
118 <Layer>
119 <Material>
120 <Name>Name</Name>
121 <Manufacturer>Manufacturer</Manufacturer>
122 ';
123 printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
124 printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
125 printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
126 print "\t\t<DeviceType>Integral</DeviceType>\n";
127 # Output MGF description if requested
128 if ( $geout ) {
129 print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
130 printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
131 open(MGFSCN, "< $mgfscn");
132 while (<MGFSCN>) { print $_; }
133 close MGFSCN;
134 print "xf\n";
135 print "\t\t</Geometry>\n";
136 }
137 print " </Material>\n";
138 # Set up surface sampling
139 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
140 my $ny = int($nsamp/$nx + .5);
141 $nsamp = $nx * $ny;
142 my $ns = 2**$ttlog2;
143 my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
144 # Create data segments (all the work happens here)
145 if ( $tensortree ) {
146 do_tree_bsdf();
147 } else {
148 do_matrix_bsdf();
149 }
150 # Output XML epilogue
151 print
152 '</Layer>
153 </Optical>
154 </WindowElement>
155 ';
156 # Clean up temporary files and exit
157 exec("rm -rf $td");
158
159 #-------------- End of main program segment --------------#
160
161 #++++++++++++++ Kill persistent rtrace +++++++++++++++++++#
162 sub persist_end {
163 if ( $persistfile && open(PFI, "< $persistfile") ) {
164 while (<PFI>) {
165 s/^[^ ]* //;
166 kill('ALRM', $_);
167 last;
168 }
169 close PFI;
170 }
171 }
172
173 #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
174 sub do_tree_bsdf {
175 # Get sampling rate and subdivide task
176 my $ns2 = $ns;
177 $ns2 /= 2 if ( $tensortree == 3 );
178 my $nsplice = $nproc;
179 $nsplice *= 10 if ($nproc > 1);
180 $nsplice = $ns2 if ($nsplice > $ns2);
181 $nsplice = 999 if ($nsplice > 999);
182 @pdiv = (0, int($ns2/$nsplice));
183 my $nrem = $ns2 % $nsplice;
184 for (my $i = 1; $i < $nsplice; $i++) {
185 my $nv = $pdiv[$i] + $pdiv[1];
186 ++$nv if ( $nrem-- > 0 );
187 push @pdiv, $nv;
188 }
189 die "Script error 1" if ($pdiv[-1] != $ns2);
190 # Shirley-Chiu mapping from unit square to disk
191 $sq2disk = '
192 in_square_a = 2*in_square_x - 1;
193 in_square_b = 2*in_square_y - 1;
194 in_square_rgn = if(in_square_a + in_square_b,
195 if(in_square_a - in_square_b, 1, 2),
196 if(in_square_b - in_square_a, 3, 4));
197 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
198 -in_square_a, -in_square_b);
199 out_disk_phi = PI/4 * select(in_square_rgn,
200 in_square_b/in_square_a,
201 2 - in_square_a/in_square_b,
202 4 + in_square_b/in_square_a,
203 if(in_square_b*in_square_b,
204 6 - in_square_a/in_square_b, 0));
205 Dx = out_disk_r*cos(out_disk_phi);
206 Dy = out_disk_r*sin(out_disk_phi);
207 Dz = sqrt(1 - out_disk_r*out_disk_r);
208 ';
209 # Shirley-Chiu mapping from unit disk to square
210 $disk2sq = '
211 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
212 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
213 in_disk_phi = norm_radians(atan2(Dy, Dx));
214 in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
215 out_square_a = select(in_disk_rgn,
216 in_disk_r,
217 (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
218 -in_disk_r,
219 (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
220 out_square_b = select(in_disk_rgn,
221 in_disk_phi*in_disk_r/(PI/4),
222 in_disk_r,
223 (PI - in_disk_phi)*in_disk_r/(PI/4),
224 -in_disk_r);
225 out_square_x = (out_square_a + 1)/2;
226 out_square_y = (out_square_b + 1)/2;
227 ';
228 # Announce ourselves in XML output
229 print "\t<DataDefinition>\n";
230 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
231 print "\t</DataDefinition>\n";
232 # Fork parallel rtcontrib processes to compute each side
233 my $npleft = $nproc;
234 if ( $doback ) {
235 for (my $splice = 0; $splice < $nsplice; $splice++) {
236 if (! $npleft ) {
237 wait();
238 die "rtcontrib process reported error" if ( $? );
239 $npleft++;
240 }
241 bg_tree_rtcontrib(0, $splice);
242 $npleft--;
243 }
244 while (wait() >= 0) {
245 die "rtcontrib process reported error" if ( $? );
246 $npleft++;
247 }
248 persist_end();
249 ttree_out(0);
250 }
251 if ( $doforw ) {
252 for (my $splice = 0; $splice < $nsplice; $splice++) {
253 if (! $npleft ) {
254 wait();
255 die "rtcontrib process reported error" if ( $? );
256 $npleft++;
257 }
258 bg_tree_rtcontrib(1, $splice);
259 $npleft--;
260 }
261 while (wait() >= 0) {
262 die "rtcontrib process reported error" if ( $? );
263 $npleft++;
264 }
265 persist_end();
266 ttree_out(1);
267 }
268 } # end of sub do_tree_bsdf()
269
270 # Run rtcontrib process in background to generate tensor tree samples
271 sub bg_tree_rtcontrib {
272 my $pid = fork();
273 die "Cannot fork new process" unless defined $pid;
274 if ($pid > 0) { return $pid; }
275 my $forw = shift;
276 my $pn = shift;
277 my $pbeg = $pdiv[$pn];
278 my $plen = $pdiv[$pn+1] - $pbeg;
279 my $matargs = "-m $bmodnm";
280 if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
281 my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
282 "-e '$disk2sq' -bn '$ns*$ns' " .
283 "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
284 "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
285 if ( $tensortree == 3 ) {
286 # Isotropic BSDF
287 $cmd = "cnt $plen $ny $nx " .
288 "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
289 "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
290 "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
291 "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
292 "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
293 "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
294 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
295 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
296 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
297 "| $cmd";
298 } else {
299 # Anisotropic BSDF
300 # Sample area vertically to improve load balance, since
301 # shading systems usually have bilateral symmetry (L-R)
302 $cmd = "cnt $plen $ns $ny $nx " .
303 "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
304 "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
305 "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
306 "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
307 "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
308 "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
309 "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
310 "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
311 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
312 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
313 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
314 "| $cmd";
315 }
316 # print STDERR "Starting: $cmd\n";
317 exec($cmd); # no return; status report to parent via wait
318 die "Cannot exec: $cmd\n";
319 } # end of bg_tree_rtcontrib()
320
321 # Simplify and output tensor tree results
322 sub ttree_out {
323 my $forw = shift;
324 my $side = ("Back","Front")[$forw];
325 my $cmd;
326 # Only output one transmitted distribution, preferring backwards
327 if ( !$forw || !$doback ) {
328 print
329 ' <WavelengthData>
330 <LayerNumber>System</LayerNumber>
331 <Wavelength unit="Integral">Visible</Wavelength>
332 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
333 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
334 <WavelengthDataBlock>
335 <WavelengthDataDirection>Transmission</WavelengthDataDirection>
336 <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
337 <ScatteringDataType>BTDF</ScatteringDataType>
338 <ScatteringData>
339 ';
340 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
341 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
342 if ($pctcull >= 0) {
343 $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
344 "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
345 system "$cmd" || die "Failure running rttree_reduce";
346 } else {
347 $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt";
348 print "{\n";
349 system "$cmd" || die "Failure running rcalc";
350 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
351 print "0\n";
352 }
353 print "}\n";
354 }
355 print
356 ' </ScatteringData>
357 </WavelengthDataBlock>
358 </WavelengthData>
359 ';
360 }
361 # Output reflection
362 print
363 ' <WavelengthData>
364 <LayerNumber>System</LayerNumber>
365 <Wavelength unit="Integral">Visible</Wavelength>
366 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
367 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
368 <WavelengthDataBlock>
369 ';
370 print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
371 print
372 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
373 <ScatteringDataType>BRDF</ScatteringDataType>
374 <ScatteringData>
375 ';
376 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
377 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
378 if ($pctcull >= 0) {
379 $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
380 "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
381 system "$cmd" || die "Failure running rttree_reduce";
382 } else {
383 $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt";
384 print "{\n";
385 system "$cmd" || die "Failure running rcalc";
386 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
387 print "0\n";
388 }
389 print "}\n";
390 }
391 print
392 ' </ScatteringData>
393 </WavelengthDataBlock>
394 </WavelengthData>
395 ';
396 } # end of ttree_out()
397
398 #------------- End of do_tree_bsdf() & subroutines -------------#
399
400 #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
401 sub do_matrix_bsdf {
402 # Set up sampling of portal
403 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
404 $tcal = '
405 DEGREE : PI/180;
406 sq(x) : x*x;
407 Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
408 Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
409 Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
410 Kmax : Kaccum(Knaz(0));
411 Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
412 Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
413 Kcol = Kbin - Kaccum(Krow-1);
414 Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
415 Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
416 sin_kpol = sin(Kpol);
417 Dx = cos(Kazi)*sin_kpol;
418 Dy = sin(Kazi)*sin_kpol;
419 Dz = sqrt(1 - sin_kpol*sin_kpol);
420 KprojOmega = PI * if(Kbin-.5,
421 (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
422 1 - sq(cos(Kpola(1)*DEGREE)));
423 ';
424 # Compute Klems bin from exiting ray direction (forward or backward)
425 $kcal = '
426 DEGREE : PI/180;
427 abs(x) : if(x, x, -x);
428 Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
429 posangle(a) : if(-a, a + 2*PI, a);
430 Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
431 kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
432 knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
433 kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
434 kfindrow(r, pol) : if(r-kpola(0)+.5, r,
435 if(pol-kpola(r), kfindrow(r+1, pol), r) );
436 kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
437 kbin2(pol,azi) = select(kfindrow(1, pol),
438 kazn(azi,360/knaz(1)),
439 kaccum(1) + kazn(azi,360/knaz(2)),
440 kaccum(2) + kazn(azi,360/knaz(3)),
441 kaccum(3) + kazn(azi,360/knaz(4)),
442 kaccum(4) + kazn(azi,360/knaz(5)),
443 kaccum(5) + kazn(azi,360/knaz(6)),
444 kaccum(6) + kazn(azi,360/knaz(7)),
445 kaccum(7) + kazn(azi,360/knaz(8)),
446 kaccum(8) + kazn(azi,360/knaz(9))
447 );
448 kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
449 ';
450 my $ndiv = 145;
451 # Compute scattering data using rtcontrib
452 my @tfarr;
453 my @rfarr;
454 my @tbarr;
455 my @rbarr;
456 my $cmd;
457 my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
458 "-e '$kcal' -b kbin -bn $ndiv " .
459 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
460 my $rccmd = "rcalc -e '$tcal' " .
461 "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
462 q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
463 if ( $doforw ) {
464 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
465 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
466 "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
467 "-e 'zp:$dim[4]' " .
468 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
469 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
470 "| $rtcmd";
471 system "$cmd" || die "Failure running: $cmd\n";
472 @tfarr = `$rccmd $td/$fmodnm.flt`;
473 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
474 @rfarr = `$rccmd $td/$bmodnm.flt`;
475 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
476 }
477 if ( $doback ) {
478 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
479 "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
480 "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
481 "-e 'zp:$dim[5]' " .
482 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
483 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
484 "| $rtcmd";
485 system "$cmd" || die "Failure running: $cmd\n";
486 @tbarr = `$rccmd $td/$bmodnm.flt`;
487 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
488 chomp(@tbarr);
489 @rbarr = `$rccmd $td/$fmodnm.flt`;
490 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
491 chomp(@rbarr);
492 }
493 # Output angle basis
494 print
495 ' <DataDefinition>
496 <IncidentDataStructure>Columns</IncidentDataStructure>
497 <AngleBasis>
498 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
499 <AngleBasisBlock>
500 <Theta>0</Theta>
501 <nPhis>1</nPhis>
502 <ThetaBounds>
503 <LowerTheta>0</LowerTheta>
504 <UpperTheta>5</UpperTheta>
505 </ThetaBounds>
506 </AngleBasisBlock>
507 <AngleBasisBlock>
508 <Theta>10</Theta>
509 <nPhis>8</nPhis>
510 <ThetaBounds>
511 <LowerTheta>5</LowerTheta>
512 <UpperTheta>15</UpperTheta>
513 </ThetaBounds>
514 </AngleBasisBlock>
515 <AngleBasisBlock>
516 <Theta>20</Theta>
517 <nPhis>16</nPhis>
518 <ThetaBounds>
519 <LowerTheta>15</LowerTheta>
520 <UpperTheta>25</UpperTheta>
521 </ThetaBounds>
522 </AngleBasisBlock>
523 <AngleBasisBlock>
524 <Theta>30</Theta>
525 <nPhis>20</nPhis>
526 <ThetaBounds>
527 <LowerTheta>25</LowerTheta>
528 <UpperTheta>35</UpperTheta>
529 </ThetaBounds>
530 </AngleBasisBlock>
531 <AngleBasisBlock>
532 <Theta>40</Theta>
533 <nPhis>24</nPhis>
534 <ThetaBounds>
535 <LowerTheta>35</LowerTheta>
536 <UpperTheta>45</UpperTheta>
537 </ThetaBounds>
538 </AngleBasisBlock>
539 <AngleBasisBlock>
540 <Theta>50</Theta>
541 <nPhis>24</nPhis>
542 <ThetaBounds>
543 <LowerTheta>45</LowerTheta>
544 <UpperTheta>55</UpperTheta>
545 </ThetaBounds>
546 </AngleBasisBlock>
547 <AngleBasisBlock>
548 <Theta>60</Theta>
549 <nPhis>24</nPhis>
550 <ThetaBounds>
551 <LowerTheta>55</LowerTheta>
552 <UpperTheta>65</UpperTheta>
553 </ThetaBounds>
554 </AngleBasisBlock>
555 <AngleBasisBlock>
556 <Theta>70</Theta>
557 <nPhis>16</nPhis>
558 <ThetaBounds>
559 <LowerTheta>65</LowerTheta>
560 <UpperTheta>75</UpperTheta>
561 </ThetaBounds>
562 </AngleBasisBlock>
563 <AngleBasisBlock>
564 <Theta>82.5</Theta>
565 <nPhis>12</nPhis>
566 <ThetaBounds>
567 <LowerTheta>75</LowerTheta>
568 <UpperTheta>90</UpperTheta>
569 </ThetaBounds>
570 </AngleBasisBlock>
571 </AngleBasis>
572 </DataDefinition>
573 ';
574 if ( $doforw ) {
575 print
576 ' <WavelengthData>
577 <LayerNumber>System</LayerNumber>
578 <Wavelength unit="Integral">Visible</Wavelength>
579 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
580 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
581 <WavelengthDataBlock>
582 <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
583 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
584 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
585 <ScatteringDataType>BTDF</ScatteringDataType>
586 <ScatteringData>
587 ';
588 # Output front transmission (transposed order)
589 for (my $od = 0; $od < $ndiv; $od++) {
590 for (my $id = 0; $id < $ndiv; $id++) {
591 print $tfarr[$ndiv*$id + $od], ",\n";
592 }
593 print "\n";
594 }
595 print
596 ' </ScatteringData>
597 </WavelengthDataBlock>
598 </WavelengthData>
599 <WavelengthData>
600 <LayerNumber>System</LayerNumber>
601 <Wavelength unit="Integral">Visible</Wavelength>
602 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
603 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
604 <WavelengthDataBlock>
605 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
606 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
607 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
608 <ScatteringDataType>BRDF</ScatteringDataType>
609 <ScatteringData>
610 ';
611 # Output front reflection (transposed order)
612 for (my $od = 0; $od < $ndiv; $od++) {
613 for (my $id = 0; $id < $ndiv; $id++) {
614 print $rfarr[$ndiv*$id + $od], ",\n";
615 }
616 print "\n";
617 }
618 print
619 ' </ScatteringData>
620 </WavelengthDataBlock>
621 </WavelengthData>
622 ';
623 }
624 if ( $doback ) {
625 print
626 ' <WavelengthData>
627 <LayerNumber>System</LayerNumber>
628 <Wavelength unit="Integral">Visible</Wavelength>
629 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
630 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
631 <WavelengthDataBlock>
632 <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
633 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
634 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
635 <ScatteringDataType>BTDF</ScatteringDataType>
636 <ScatteringData>
637 ';
638 # Output back transmission (transposed order)
639 for (my $od = 0; $od < $ndiv; $od++) {
640 for (my $id = 0; $id < $ndiv; $id++) {
641 print $tbarr[$ndiv*$id + $od], ",\n";
642 }
643 print "\n";
644 }
645 print
646 ' </ScatteringData>
647 </WavelengthDataBlock>
648 </WavelengthData>
649 <WavelengthData>
650 <LayerNumber>System</LayerNumber>
651 <Wavelength unit="Integral">Visible</Wavelength>
652 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
653 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
654 <WavelengthDataBlock>
655 <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
656 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
657 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
658 <ScatteringDataType>BRDF</ScatteringDataType>
659 <ScatteringData>
660 ';
661 # Output back reflection (transposed order)
662 for (my $od = 0; $od < $ndiv; $od++) {
663 for (my $id = 0; $id < $ndiv; $id++) {
664 print $rbarr[$ndiv*$id + $od], ",\n";
665 }
666 print "\n";
667 }
668 print
669 ' </ScatteringData>
670 </WavelengthDataBlock>
671 </WavelengthData>
672 ';
673 }
674 }
675 #------------- End of do_matrix_bsdf() --------------#